AbstractSequentialList

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.util
Class AbstractSequentialList

    java.lang.Object
      java.util.AbstractCollection
          java.util.AbstractList
              java.util.AbstractSequentialList

All Implemented Interfaces:
  Collection, List

Direct Known Subclasses:
  LinkedList

    public abstract class AbstractSequentialList

extends AbstractList

This class provides a skeletal implementation of the `List` interface to minimize the effort required to implement this interface backed by a "sequential access" data store (such as a linked list). For random access data (such as an array), `AbstractList` should be used in preference to this class.

This class is the opposite of the `AbstractList` class in the sense that it implements the "random access" methods (`get(int index)`, `set(int index, Object element)`, `set(int index, Object element)`, `add(int index, Object element)` and `remove(int index)`) on top of the list's list iterator, instead of the other way around.

To implement a list the programmer needs only to extend this class and provide implementations for the `listIterator` and `size` methods. For an unmodifiable list, the programmer need only implement the list iterator's `hasNext`, `next`, `hasPrevious`, `previous` and `index` methods.

For a modifiable list the programmer should additionally implement the list iterator's `set` method. For a variable-size list the programmer should additionally implement the list iterator's `remove` and `add` methods.

The programmer should generally provide a void (no argument) and collection constructor, as per the recommendation in the `Collection` interface specification.

This class is a member of the Java Collections Framework.

Since:
  1.2
Version:
  1.21, 02/02/00
Author:
  Josh Bloch
See Also:
  `Collection`, `List`, `AbstractList`, `AbstractCollection`

Method Summary
`void` | `add(int index, Object element)` Inserts the specified element at the specified position in this list.
`boolean` | `addAll(int index, Collection c)` Inserts all of the elements in in the specified collection into this list at the specified position.
`Object` | `get(int index)` Returns the element at the specified position in this list.
`Iterator` | `iterator()` Returns an iterator over the elements in this list (in proper sequence).
`abstract ListIterator` | `listIterator(int index)` Returns a list iterator over the elements in this list (in proper sequence).
`Object` | `remove(int index)` Removes the element at the specified position in this list.
`Object` | `set(int index, Object element)` Replaces the element at the specified position in this list with the specified element.

Methods inherited from class java.util.AbstractList
`add, clear, equals, hashCode, indexOf, lastIndexOf, listIterator, subList`

Methods inherited from class java.util.AbstractCollection
`addAll, contains, containsAll, isEmpty, remove, removeAll, retainAll, size, toArray, toArray, toString`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.List
`addAll, contains, containsAll, isEmpty, remove, removeAll, retainAll, size, toArray, toArray`

Method Detail

### get

    public Object get(int index)

  Returns the element at the specified position in this list.

  This implementation first gets a list iterator pointing to the indexed element (with `listIterator(index)`). Then, it gets the element using `ListIterator.next` and returns it.

  Specified by:
    `get` in interface `List`
  Specified by:
    `get` in class `AbstractList`
  Parameters:
    `index` - index of element to return.
  Returns:
    the element at the specified position in this list.
  Throws:
    `IndexOutOfBoundsException` - if the specified index is out of range (`index < 0 || index >= size()`).

### set

    public Object set(int index,
                      Object element)

  Replaces the element at the specified position in this list with the specified element.

  This implementation first gets a list iterator pointing to the indexed element (with `listIterator(index)`). Then, it gets the current element using `ListIterator.next` and replaces it with `ListIterator.set`.

  Note that this implementation will throw an UnsupportedOperationException if list iterator does not implement the set operation.

  Specified by:
    `set` in interface `List`
  Overrides:
    `set` in class `AbstractList`
  Parameters:
    `index` - index of element to replace.
    `element` - element to be stored at the specified position.
  Returns:
    the element previously at the specified position.
  Throws:
    `UnsupportedOperationException` - set is not supported by this list.
    `NullPointerException` - this list does not permit null elements and one of the elements of `c` is null.
    `ClassCastException` - class of the specified element prevents it from being added to this list.
    `IllegalArgumentException` - some aspect of the specified element prevents it from being added to this list.
    `IndexOutOfBoundsException` - index out of range `(index < 0 || index >= size()`).
    `IllegalArgumentException` - fromIndex > toIndex.

### add

    public void add(int index,
                    Object element)

  Inserts the specified element at the specified position in this list. Shifts the element currently at that position (if any) and any subsequent elements to the right (adds one to their indices).

  This implementation first gets a list iterator pointing to the indexed element (with `listIterator(index)`). Then, it inserts the specified element with `ListIterator.add`.

  Note that this implementation will throw an `UnsupportedOperationException` if list iterator does not implement the `add` operation.

  Specified by:
    `add` in interface `List`
  Overrides:
    `add` in class `AbstractList`
  Parameters:
    `index` - index at which the specified element is to be inserted.
    `element` - element to be inserted.
  Throws:
    `UnsupportedOperationException` - if the `add` operation is not supported by this list.
    `NullPointerException` - this list does not permit `null` elements and one of the elements of `c` is `null`.
    `ClassCastException` - if the class of the specified element prevents it from being added to this list.
    `IllegalArgumentException` - if some aspect of the specified element prevents it from being added to this list.
    `IndexOutOfBoundsException` - if the specified index is out of range (`index < 0 || index > size()`).

### remove

    public Object remove(int index)

  Removes the element at the specified position in this list. Shifts any subsequent elements to the left (subtracts one from their indices).

  This implementation first gets a list iterator pointing to the indexed element (with `listIterator(index)`). Then, it removes the element with `ListIterator.remove`.

  Note that this implementation will throw an `UnsupportedOperationException` if list iterator does not implement the `remove` operation.

  Specified by:
    `remove` in interface `List`
  Overrides:
    `remove` in class `AbstractList`
  Parameters:
    `index` - index of the element to be removed from the List.
  Returns:
    the element that was removed from the list.
  Throws:
    `UnsupportedOperationException` - if the `remove` operation is not supported by this list.
    `IndexOutOfBoundsException` - if the specified index is out of range (index < 0 || index >= size()).

### addAll

    public boolean addAll(int index,
                          Collection c)

  Inserts all of the elements in in the specified collection into this list at the specified position. Shifts the element currently at that position (if any) and any subsequent elements to the right (increases their indices). The new elements will appear in the list in the order that they are returned by the specified collection's iterator. The behavior of this operation is unspecified if the specified collection is modified while the operation is in progress. (Note that this will occur if the specified collection is this list, and it's nonempty.) Optional operation.

  This implementation gets an iterator over the specified collection and a list iterator over this list pointing to the indexed element (with `listIterator(index)`). Then, it iterates over the specified collection, inserting the elements obtained from the iterator into this list, one at a time, using `ListIterator.add` followed by `ListIterator.next` (to skip over the added element).

  Note that this implementation will throw an `UnsupportedOperationException` if the list iterator returned by the `listIterator` method does not implement the `add` operation.

  Specified by:
    `addAll` in interface `List`
  Overrides:
    `addAll` in class `AbstractList`
  Parameters:
    `index` - index at which to insert first element from the specified collection.
    `c` - elements to be inserted into this list.
  Returns:
    `true` if this list changed as a result of the call.
  Throws:
    `UnsupportedOperationException` - if the `addAll` operation is not supported by this list.
    `NullPointerException` - this list does not permit `null` elements and one of the elements of the specified collection is `null`.
    `ClassCastException` - if the class of the specified element prevents it from being added to this list.
    `IllegalArgumentException` - if some aspect of the specified element prevents it from being added to this list.
    `IndexOutOfBoundsException` - if the specified index is out of range (`index < 0 || index > size()`).
    `NullPointerException` - if the specified collection is null.

### iterator

    public Iterator iterator()

  Returns an iterator over the elements in this list (in proper sequence).

  This implementation merely returns a list iterator over the list.

  Specified by:
    `iterator` in interface `Collection`
  Specified by:
    `iterator` in interface `List`
  Overrides:
    `iterator` in class `AbstractList`
  Returns:
    an iterator over the elements in this list (in proper sequence).
  See Also:
    `AbstractList.modCount`

### listIterator

    public abstract ListIterator listIterator(int index)

  Returns a list iterator over the elements in this list (in proper sequence).

  Specified by:
    `listIterator` in interface `List`
  Overrides:
    `listIterator` in class `AbstractList`
  Parameters:
    `index` - index of first element to be returned from the list iterator (by a call to the `next` method)
  Returns:
    a list iterator over the elements in this list (in proper sequence).
  See Also:
    `AbstractList.modCount`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD